From f48e97e55a31de50b4c0b455db48bbcc7554b9fc Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 01 2020 21:17:17 +0000
Subject: [PATCH 789/2232] Use correct target dir determined by cargo


---

diff --git a/gen/build/src/cargo.rs b/gen/build/src/cargo.rs
new file mode 100644
index 0000000..91f229d
--- /dev/null
+++ b/gen/build/src/cargo.rs
@@ -0,0 +1,30 @@
+use crate::error::TargetDirError;
+use std::path::PathBuf;
+use std::process::Command;
+use std::str;
+
+pub(crate) fn target_dir() -> Result<PathBuf, TargetDirError> {
+    let cargo = option_env!("CARGO").unwrap_or("cargo");
+    let output = Command::new(cargo)
+        .arg("metadata")
+        .arg("--no-deps")
+        .arg("--format-version=1")
+        .output()
+        .map_err(TargetDirError::Io)?;
+
+    (|| {
+        // Cargo only outputs utf8 encoded JSON.
+        let mut metadata = str::from_utf8(&output.stdout).ok()?;
+
+        let key_pattern = "\"target_directory\":";
+        let key_index = metadata.rfind(key_pattern)?;
+        metadata = &metadata[key_index + key_pattern.len()..];
+        let open_quote_index = metadata.find('"')?;
+        metadata = &metadata[open_quote_index + 1..];
+        let close_quote_index = metadata.find('"')?;
+        let string = &metadata[..close_quote_index];
+        let target_directory = string.replace("\\\\", "\\");
+        Some(PathBuf::from(target_directory))
+    })()
+    .ok_or(TargetDirError::NotFound)
+}
diff --git a/gen/build/src/error.rs b/gen/build/src/error.rs
index e1bfff2..ed4c6af 100644
--- a/gen/build/src/error.rs
+++ b/gen/build/src/error.rs
@@ -1,21 +1,28 @@
 use crate::gen::fs;
 use std::error::Error as StdError;
 use std::fmt::{self, Display};
+use std::io;
 
 pub(super) type Result<T, E = Error> = std::result::Result<T, E>;
 
 #[derive(Debug)]
 pub(super) enum Error {
     MissingOutDir,
-    TargetDir,
+    TargetDir(TargetDirError),
     Fs(fs::Error),
 }
 
+#[derive(Debug)]
+pub(crate) enum TargetDirError {
+    Io(io::Error),
+    NotFound,
+}
+
 impl Display for Error {
     fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
         match self {
             Error::MissingOutDir => write!(f, "missing OUT_DIR environment variable"),
-            Error::TargetDir => write!(f, "failed to locate target dir"),
+            Error::TargetDir(_) => write!(f, "unable to identify target dir"),
             Error::Fs(err) => err.fmt(f),
         }
     }
@@ -24,6 +31,10 @@ impl Display for Error {
 impl StdError for Error {
     fn source(&self) -> Option<&(dyn StdError + 'static)> {
         match self {
+            Error::TargetDir(err) => match err {
+                TargetDirError::Io(err) => Some(err),
+                TargetDirError::NotFound => None,
+            },
             Error::Fs(err) => err.source(),
             _ => None,
         }
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 1b4bbaa..2560aee 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -52,6 +52,7 @@
     clippy::toplevel_ref_arg
 )]
 
+mod cargo;
 mod error;
 mod gen;
 mod paths;
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index 7c572ec..82cb5cc 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -1,3 +1,4 @@
+use crate::cargo;
 use crate::error::{Error, Result};
 use crate::gen::fs;
 use std::env;
@@ -72,13 +73,19 @@ pub(crate) fn include_dir() -> Result<PathBuf> {
 }
 
 fn target_dir() -> Result<PathBuf> {
+    let fallback_err = match cargo::target_dir() {
+        Ok(target_dir) => return Ok(target_dir),
+        Err(err) => Error::TargetDir(err),
+    };
+
+    // Fallback if Cargo did not work.
     let mut dir = out_dir().and_then(canonicalize)?;
     loop {
         if dir.ends_with("target") {
             return Ok(dir);
         }
         if !dir.pop() {
-            return Err(Error::TargetDir);
+            return Err(fallback_err);
         }
     }
 }

